## poselib 2.0.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

project(PoseLib VERSION 2.0.4)

# Compilation flags function
function(set_compile_flags build_target)
if(MSVC)
	target_compile_options(${build_target} PRIVATE /bigobj /fp:fast)
else()
	target_compile_options(${build_target} PRIVATE
		-O3 -Wall -Werror -fPIC -Wno-sign-compare -Wfatal-errors)
	if(MARCH_NATIVE)
		target_compile_options(${build_target} PRIVATE -march=native)
	endif()
	if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
		target_compile_options(${build_target} PRIVATE
				-Wno-maybe-uninitialized)
	endif()
endif()
target_compile_features(${build_target} PUBLIC cxx_std_17)
endfunction()

# Set variables
set(LIBRARY_NAME   ${PROJECT_NAME})
set(LIBRARY_FOLDER ${PROJECT_NAME})
include(${PROJECT_SOURCE_DIR}/cmake/SetEnv.cmake)

# Eigen
find_package(Eigen3 REQUIRED)

# Library sources
add_subdirectory(${LIBRARY_FOLDER})

# Benchmark
option(WITH_BENCHMARK "Build benchmark example." OFF)
if(WITH_BENCHMARK)
	add_subdirectory(benchmark)
endif()


# Compilation options
option(MARCH_NATIVE "Enable CPU specific optimizations" OFF)
set_compile_flags(${LIBRARY_NAME})

# python bindings
option(PYTHON_PACKAGE "Build python package." OFF)
if(PYTHON_PACKAGE)
	add_subdirectory(pybind)
endif()

=== PoseLib/CMakeLists.txt ===
# Set SOURCES variable
set(SOURCES
    solvers/gp3p.cc
    solvers/gp4ps.cc
    solvers/p1p2ll.cc
    solvers/p2p1ll.cc
    solvers/p2p2pl.cc
    solvers/p3ll.cc
    solvers/p3p.cc
    solvers/p3p_lambdatwist.cc
    solvers/p4pf.cc
    solvers/p5lp_radial.cc
    solvers/p6lp.cc
    solvers/ugp2p.cc
    solvers/ugp3ps.cc
    solvers/up1p2pl.cc
    solvers/up2p.cc
    solvers/up1p1ll.cc
    solvers/up4pl.cc
    solvers/ugp4pl.cc
    solvers/relpose_upright_3pt.cc
    solvers/relpose_upright_planar_2pt.cc
    solvers/relpose_upright_planar_3pt.cc
    solvers/relpose_8pt.cc
    solvers/relpose_5pt.cc
    solvers/relpose_7pt.cc
    solvers/relpose_6pt_focal.cc
    solvers/gen_relpose_upright_4pt.cc
    solvers/gen_relpose_5p1pt.cc
    solvers/gen_relpose_6pt.cc
    solvers/homography_4pt.cc
    misc/qep.cc
    misc/univariate.cc
    misc/essential.cc
    misc/re3q3.cc
    misc/colmap_models.cc
        misc/decompositions.cc
    robust.cc
    robust/ransac.cc
    robust/bundle.cc
    robust/utils.cc
    robust/sampling.cc
    robust/estimators/absolute_pose.cc
    robust/estimators/relative_pose.cc
    robust/estimators/hybrid_pose.cc
    robust/estimators/homography.cc
)

# Set HEADERS_PUBLIC variable
set(HEADERS_PUBLIC
    alignment.h
    solvers/gp3p.h
    solvers/gp4ps.h
    solvers/p1p2ll.h
    solvers/p2p1ll.h
    solvers/p2p2pl.h
    solvers/p3ll.h
    solvers/p3p.h
    solvers/p3p_lambdatwist.h
    solvers/p4pf.h
    solvers/p5lp_radial.h
    solvers/p6lp.h
    solvers/ugp2p.h
    solvers/ugp3ps.h
    solvers/up1p2pl.h
    solvers/up2p.h
    solvers/up1p1ll.h
    solvers/up4pl.h
    solvers/ugp4pl.h
    solvers/relpose_upright_3pt.h
    solvers/relpose_upright_planar_2pt.h
    solvers/relpose_upright_planar_3pt.h
    solvers/relpose_8pt.h
    solvers/relpose_5pt.h
    solvers/relpose_7pt.h
    solvers/relpose_6pt_focal.h
    solvers/gen_relpose_upright_4pt.h
    solvers/gen_relpose_5p1pt.h
    solvers/gen_relpose_6pt.h
    solvers/homography_4pt.h
    misc/quaternion.h
    misc/colmap_models.h
    misc/qep.h
    misc/univariate.h
    misc/sturm.h
    misc/essential.h
    misc/re3q3.h
        misc/decompositions.h
    robust.h
    types.h
    camera_pose.h
    alignment.h
    robust/ransac.h
    robust/ransac_impl.h
    robust/bundle.h
    robust/utils.h
    robust/sampling.h
    robust/lm_impl.h
    robust/jacobian_impl.h
    robust/estimators/absolute_pose.h
    robust/estimators/relative_pose.h
    robust/estimators/hybrid_pose.h
    robust/estimators/homography.h
)

# Set HEADERS_PRIVATE variable
set(HEADERS_PRIVATE )

# library configuration
include(${PROJECT_SOURCE_DIR}/cmake/LibraryConfig.cmake)

# Eigen
target_link_libraries(${LIBRARY_NAME} Eigen3::Eigen)

=== benchmark/CMakeLists.txt ===
add_executable(benchmark
    benchmark.cc
    problem_generator.cc
)

target_link_libraries(benchmark PRIVATE PoseLib::PoseLib Eigen3::Eigen)
set_compile_flags(benchmark)

install(
  TARGETS benchmark
  RUNTIME DESTINATION bin
  COMPONENT "${INSTALL_BIN_DIR}"
)

=== pybind/CMakeLists.txt ===
# setup PYTHON_EXECUTABLE

find_package (Python COMPONENTS Interpreter Development)
message(STATUS "Python_EXECUTABLE: " ${Python_EXECUTABLE})

option(GENERATE_STUBS "Whether to generate stubs" ON)

add_subdirectory(pybind11)

pybind11_add_module(pyposelib MODULE pyposelib.cc)
target_link_libraries(pyposelib PUBLIC PoseLib::PoseLib Eigen3::Eigen)
set_target_properties(pyposelib PROPERTIES OUTPUT_NAME _core)
set_compile_flags(pyposelib)

# Install the compiled module
install(TARGETS pyposelib LIBRARY DESTINATION . COMPONENT python)

if(GENERATE_STUBS)
    message(STATUS "Enabling stubs generation")
    set(STUBGEN_OUTPUT_DIR "${CMAKE_CURRENT_BINARY_DIR}/_core")
    add_custom_command(
        TARGET pyposelib POST_BUILD
        COMMAND
          "${CMAKE_COMMAND}" -E env
          "PYTHONPATH=$<TARGET_FILE_DIR:pyposelib>$<SEMICOLON>$ENV{PYTHONPATH}"
          "${Python_EXECUTABLE}" "${PROJECT_SOURCE_DIR}/pybind/generate_stubs.py" "${Python_EXECUTABLE}" "${CMAKE_CURRENT_BINARY_DIR}"
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        COMMENT "Generating pybind11 stubs"
        VERBATIM
    )
    
    # Install the generated stub file (handle both single file and directory cases)
    # Most pybind11_stubgen versions create a single .pyi file
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/_core.pyi" 
            DESTINATION .
            COMPONENT python
            OPTIONAL)  # OPTIONAL in case it doesn't exist
            
    # Some versions might create a directory instead
    install(DIRECTORY "${STUBGEN_OUTPUT_DIR}/" 
            DESTINATION .
            COMPONENT python
            OPTIONAL)  # OPTIONAL in case it doesn't exist
endif()

=== debian/changelog ===
poselib (2.0.5-1) unstable; urgency=medium

  * Initial release. (Closes: #1118718)

 -- Alex Myczko <tar@debian.org>  Fri, 24 Oct 2025 10:03:10 +0200

=== debian/control ===
Source: poselib
Section: libs
Priority: optional
Maintainer: Alex Myczko <tar@debian.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libeigen3-dev,
Standards-Version: 4.7.2
Homepage: https://github.com/PoseLib/PoseLib
Vcs-Browser: https://salsa.debian.org/debian/poselib
Vcs-Git: https://salsa.debian.org/debian/poselib.git

Package: libposelib
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: Minimal solvers for calibrated camera pose estimation
 This library provides a collection of minimal solvers for camera pose
 estimation. The focus is on calibrated absolute pose estimation problems
 from different types of correspondences.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

# See FEATURE AREAS in dpkg-buildflags(1).
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# See ENVIRONMENT in dpkg-buildflags(1).
# Package maintainers to append CFLAGS.
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# Package maintainers to append LDFLAGS.
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
	-DBUILD_SHARED_LIBS=ON \
	-DCMAKE_BUILD_WITH_INSTALL_RPATH=FALSE \
	-DCMAKE_SKIP_RPATH=ON
#	-DPYTHON_PACKAGE=ON \

=== debian/watch ===
version=4
# GitHub hosted projects.
opts="filenamemangle=s%(?:.*?)?v?(@ANY_VERSION@@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
    https://github.com/PoseLib/PoseLib/tags \
    (?:.*?/)v?@ANY_VERSION@@ARCHIVE_EXT@
